<?php namespace App\Models;

use App\Entities\Assistente\Assistente;

class AssistenteModel extends ModelEntity
{
    protected $table = 'assistente';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'id_profissional',
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;

    public function registerAssistente (Assistente &$assistente) : void {
        $assistente_data = $assistente->toArray();
        unset($assistente_data['id']);
        $id_new_assistente = $this->insert($assistente_data);
        $assistente->setId($id_new_assistente);

    }

    public function updateAssistenteByID (int $id_paciente, Assistente $assistente) : bool {
        $data = $assistente->toArray(true);
        if (count($data) > 0) {
            $binds = ['id_paciente' => $id_paciente];
            $sql = "
                UPDATE paciente
            ";
            $sql .= $this->generateUpdateSets($data, $binds);
            $sql .= 'WHERE paciente.id = :id_paciente:';
            $query = $this->db->query($sql, $binds);
            $errors = $this->errors();
            return !$errors;
        } else {
            return true;
        }
    }
}
